## Errors

You can read this section to obtain a list of possible errors, including their HTTP status codes and additional attributes.

The Store API currently has the following errors:

HTTP Response Status | Error Name             | Description
-------------------- | ---------------------- | -------
401                  | Unauthorized           | Invalid Authentication Token.
403                  | Forbidden              | You are not authorized to perform this action.
404                  | Not Found              | The resource could not be found on the server.
406                  | Not Acceptable         | The server cannot produce a response matching the list acceptable values defined in the request headers.
406                  | Unsupported Language   | The requested language '`<language-code>`' is not supported. Please use one of the supported languages: 'pt, en, es'.
415                  | Unsupported Media Type | Invalid Accept Header. Use application/vnd.api+json to perform this request.
422                  | Country is not valid   | The requested country code '`<country-code>`' is invalid. Please provide a valid country code from ISO 3166-1 A-2.
422                  | Unsupported Country    | The requested country code '`<country-code>`' is not currently supported. 'Please choose an available country.

### Understanding errors

> Example error response:

```json
{
  "errors": [
    {
      "title": "Unauthorized",
      "detail": "Invalid Authentication Token",
      "status": "401",
      "source": "/root",
      "code": "internal_code_error_string",
      "links": {
        "service-doc": "https://docs.nuuvem.com/#errors"
      }
    }
  ]
}
```

Error responses are as descriptive as possible, and sometimes contain extra fields to help clients understand why the error occurred.

Below you'll be able to find more about each key in the error response payload.

Key                   | Description
--------------------- | -------------------------------------------------------------------------------------------------- |
`title`               | A short, human-readable summary of the problem                                                     |
`detail`              | A human-readable explanation specific to this occurrence of the problem                            |
`status`              | The HTTP status code applicable to this problem, expressed as a string value                       |
`source`              | An object containing references to the primary source of the error                                 |
`code`                | An application-specific error code, expressed as a string value                                    |
`links`               | Representation of useful internal links that points to resources or the service documentation      |
`links > service-doc` | Identifies service documentation for the context that is primarily intended for human consumption  |

### Custom error codes

Custom error codes are descriptive internal error strings that represent specific application-level errors which do not have a corresponding HTTP status code.
Instead, these custom codes reuse existing HTTP status codes and provide additional context through the code key in the response payload.

Below is a list of our custom error codes:

Value                               | Description
----------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
`product_package_not_supported_yet` | This error indicates that the API currently does not support Product Packages. When you request a product ID that corresponds to a Product Package, you will receive an error with this code. |

<aside class="notice">
Some of these custom error codes are temporary and indicate features or endpoints that are not yet implemented.
</aside>
